// 2004 spss syntax downloaded from cls website at http://www.cls.ioe.ac.uk/page.aspx?&sitesectionid=847&sitesectiontitle=data+notes , 23/4/2014
// i then merged this wtih the 2000 syntax from kenzo (via cls)

/* comments in the 2004 spss syntax
* comment  this syntax (nov 2010) uses the same alg|ithm as that f| the 1999/2000 sweep to calculate highest academic & vocational qualifications reported at 2004 sweep.
* it then merges the highest qualification inf|mation from 2004 with highest qual info from the 2000 sweep to create "highest quals ever up to 2004" variables.
*/

use original_datafiles\bcs_2004_followup.dta, replace
/* Rather than keeping all of the individual variables, I do this on the original dataset before merging, & keep the dv */

**cses
gen cse1 = 0
	replace cse1 = 1 if ((b7eqtp14==1 | b7eqtp15==1 | b7eqtp16==1 | b7eqtp17==1 | b7eqtp18==1 | b7eqtp19==1 | b7eqtp20==1) & b7edcse1 > 0)
	label var cse1 "at least one cse grade 1 (good o level)"
gen cse2 = 0.
	replace cse2 = 1 if ((b7eqtp14==1 | b7eqtp15==1 | b7eqtp16==1 | b7eqtp17==1 | b7eqtp18==1 | b7eqtp19==1 | b7eqtp20==1) & b7edcse2 > 0)
	label var cse2 "at least one cse grade 2-5 (bad o level)"
tab1 cse1 cse2


**gcses.
gen gcse1 = 0
	replace gcse1=1 if ((b7eqtp14==2 | b7eqtp15==2 | b7eqtp16==2 | b7eqtp17==2 | b7eqtp18==2 | b7eqtp19==2 | b7eqtp20==2) & b7edgcs1 > 0)
	label var gcse1 "at least one gcse grade a-c (good o level)"
gen gcse2 = 0
	replace gcse2=1 if ((b7eqtp14==2 | b7eqtp15==2 | b7eqtp16==2 | b7eqtp17==2 | b7eqtp18==2 | b7eqtp19==2 | b7eqtp20==2) & b7edgcs2 > 0) 
	label var gcse2 "at least one cse grade d-e ( bad o level)"
tab1 gcse1 gcse2
tab b7edgcs1 gcse1
tab b7edgcs2 gcse2


**gces.
tab b7edole1 b7edole2
gen gce1 = 0
	replace gce1=1 if ((b7eqtp14==3 | b7eqtp15==3 | b7eqtp16==3 | b7eqtp17==3 | b7eqtp18==3 | b7eqtp19==3 | b7eqtp20==3) & b7edole1 > 0)
	label var gce1 "at least one gce o levels grades a-c"
gen gce2 = 0
	replace gce2=1 if ((b7eqtp14==3 | b7eqtp15==3 | b7eqtp16==3 | b7eqtp17==3 | b7eqtp18==3 | b7eqtp19==3 | b7eqtp20==3) & b7edole2 > 0)
	label var gce2 "at least one gce o levels grades d-e"
tab gce1 gce2


**scottish qualifications.
**as levels.
tab b7edasl1 b7edasl2
gen as1 = 0
	replace as1=1 if ((b7eqtp14==4 | b7eqtp15==4 | b7eqtp16==4 | b7eqtp17==4 | b7eqtp18==4 | b7eqtp19==4 | b7eqtp20==4) & b7edasl1 >=1) 
	label var as1 "at least one a/s level grades a-c"
gen as2 = 0
	replace as2=1 if ((b7eqtp14==4 | b7eqtp15==4 | b7eqtp16==4 | b7eqtp17==4 | b7eqtp18==4 | b7eqtp19==4 | b7eqtp20==4) & b7edasl2 >=1)
	label var as2 "at least one a/s level grades d-g"
tab as1 as2


**a levels.
gen al1 = 0
	replace al1=1 if ((b7eqtp14==5 | b7eqtp15==5 | b7eqtp16==5 | b7eqtp17==5 | b7eqtp18==5 | b7eqtp19==5 | b7eqtp20==5) & b7edgcl1 ==1)
	replace al1=2 if ((b7eqtp14==5 | b7eqtp15==5 | b7eqtp16==5 | b7eqtp17==5 | b7eqtp18==5 | b7eqtp19==5 | b7eqtp20==5) & b7edgcl1 >1)
	label var al1 "at least one a level grades a-c"
gen al2 = 0
	replace al2=1 if ((b7eqtp14==5 | b7eqtp15==5 | b7eqtp16==5 | b7eqtp17==5 | b7eqtp18==5 | b7eqtp19==5 | b7eqtp20==5) & b7edgcl2 ==1) 
	replace al2=2 if ((b7eqtp14==5 | b7eqtp15==5 | b7eqtp16==5 | b7eqtp17==5 | b7eqtp18==5 | b7eqtp19==5 | b7eqtp20==5) & b7edgcl2 >1)
	label var al2 "at least one a level grades d-g"
label define al1 0 "none" 1 "one" 2 "> than 1"
label values al1 al1
label values al2 al1
tab al1 al2


**btecs.
tab1 b7btcev b7btcev2 b7btcev3 b7btcev4 b7btcev5 b7btcev6 b7btcev7 b7btcev8 b7btcev9 b7btce10
tab1 b7btcev b7btcev2 b7btcev3 b7btcev4 b7btcev5 b7btcev6 b7btcev7 b7btcev8 b7btcev9 b7btce10, nol
clonevar b7btcev1  = b7btcev 	// BB addition: To enable looping
clonevar b7btcev10 = b7btce10	// BB addition: To enable looping
forvalues i = 1/5	{
	gen btec`i' = 0
	forvalues j = 1/10	{
		replace btec`i' = 1 if b7btcev`j'==`i'
	/**/				}
/**/				}
tab1 btec1 btec2 btec3 btec4 btec5


** city & guilds .
tab1 b7ctyev b7ctyev2 b7ctyev3 b7ctyev4 b7ctyev5 b7ctyev6 b7ctyev7 b7ctyev8 b7ctyev9 b7ctye10
clonevar b7ctyev1  = b7ctyev
clonevar b7ctyev10 = b7ctye10
**city 6 = don"t know.
forvalues i = 1/6	{
	gen city`i' = 0
	forvalues j = 1/10	{
		replace city`i' = 1 if b7ctyev`j'==`i'
	/**/				}
/**/				}
tab1 city1 city2 city3 city4 city5 city6


**rsa awarded .
tab1 b7rsal b7rsal2 b7rsal3 b7rsal4 b7rsal5 b7rsal6 b7rsal7 b7rsal8 b7rsal9 b7rsal10 b7rsal11 b7rsal12
clonevar b7rsal1 = b7rsal 
forvalues i = 1/5	{
	gen rsa`i' = 0
	forvalues j = 1/12	{
		replace rsa`i' = 1 if b7rsal`j'==`i'
	/**/				}
/**/				}
tab1 rsa1 rsa2 rsa3 rsa4 rsa5


*pitman awarded .
tab1 b7pitl b7pitl2 b7pitl3 b7pitl4 b7pitl5
clonevar b7pitl1 = b7pitl 
forvalues i = 1/4	{
	gen pit`i' = 0
	forvalues j = 1/5	{
		replace pit`i' = 1 if b7pitl`j'==`i'
	/**/				}
/**/				}
tab1 pit1 pit2 pit3 pit4



*nvq awarded - .
tab1 b7nvql b7nvql2 b7nvql3 b7nvql4 b7nvql5
clonevar b7nvql1 = b7nvql 
forvalues i = 1/8	{
	gen nvq`i' = 0
	forvalues j = 1/5	{
		replace nvq`i' = 1 if b7nvql`j'==`i'
	/**/				}
/**/				}
tab1 nvq1 nvq2 nvq3 nvq4 nvq5 nvq6 nvq7 nvq8


* gnvq awarded.
tab1 b7gnvl b7gnvl2 b7gnvl3
clonevar b7gnvl1 = b7gnvl 
forvalues i = 1/4	{
	gen gnvq`i' = 0
	forvalues j = 1/3	{
		replace gnvq`i' = 1 if b7gnvl`j'==`i'
	/**/				}
/**/				}
tab1 gnvq1 gnvq2 gnvq3 gnvq4


** onc awarded .
tab1 b7onll b7onll2 b7onll3 b7onll4 b7onll5 b7onll6
clonevar b7onll1 = b7onll 
forvalues i = 1/6	{
	gen onc`i' = 0
	forvalues j = 1/3	{
		replace onc`i' = 1 if b7onll`j'==`i'
	/**/				}
/**/				}
tab1 onc1 onc2 onc3


**hnc / hnds etc.
tab1 b7hll b7hll2 b7hll3
clonevar b7hll1 = b7hll 
forvalues i = 1/3	{
	gen hnc`i' = 0
	forvalues j = 1/3	{
		replace hnc`i' = 1 if b7hll`j'==`i'
	/**/				}
/**/				}
tab1 hnc1 hnc2 hnc3


* Checks and comparisons (BB: I"m not quite sure what these do...)
tab1 bd7cse bd7gcse bd7gce bd7as bd7gcas bd7ssc bd7dhe bd7deg bd7odeg bd7hdeg bd7nq bd7pgce bd7otht bd7acad bd7vqdn
tab bd7cse cse1



********************************************************************************************************************.
**highest academic qualification reported in 2004: coded to match hiaca00 variable in 2000 survey.
********************************************************************************************************************.
	/*reminder that scottish standard, intermediate 1 qualifications are placed as equivalent to gcses.
	i think this is accurate - investigations refer to grades (foundation, etc) of these but we did not collect grades/levels.
	in this variable (bd7achq1) intermediate 2 is coded as equivalent to an as level (code 4) but in recoded bd7anvq1 variable
	(below) both intermediate 1 & intermediate 2 are coded as equivalent to nvq2 (code 2).
	i cannot find exact equivalent framework however - but students take intermediate 2 prior to a higher - intermediate 1 is 
	taken after or instead of a standard grade.*/

gen bd7achq1= -1
	replace bd7achq1 = 0 if (b7eqtp14 == 14) 
	replace bd7achq1 = 1 if (cse2==1 | gcse2 == 1 | gce2 == 1) 
	replace bd7achq1 = 2 if (b7edsco1 == 6 | b7edsco2 == 6) 
	replace bd7achq1 = 3 if (cse1==1 | gcse1 == 1 | gce1 == 1 | b7edsco1==1 | b7edsco2==1)
	replace bd7achq1 = 4 if (as1 ==1 | as2 ==1 | al1==1 | al2==1 | b7edsco1==2 | b7edsco1==3 | b7edsco2==2 | b7edsco2==3) 
	replace bd7achq1 = 5 if (b7edgcl1 > 1 | b7edsco1==4 | b7edsco1==5 | b7edsco2==4 | b7edsco2==5 | al2==2 ) 
	replace bd7achq1 = 6 if (bd7dhe == 1) 
	replace bd7achq1 = 7 if (bd7deg==1 | bd7pgce==1 | bd7odeg==1) 
	replace bd7achq1 = 8 if (bd7hdeg == 1) 

* if b7eqtp-variables indicate cses, gsces | gcses obtained, assume lowest & fewest.
replace bd7achq1=1 if ((b7eqtp14==1 | b7eqtp15==1) & bd7achq1==-1) | ((b7eqtp14==2 | b7eqtp15==2) & bd7achq1==-1)| ((b7eqtp14==3 | b7eqtp15==3) & bd7achq1==-1)
* if b7eqtp-variables indicate a/s level | a level obtained, assume lowest & fewest.
replace bd7achq1=4 if ((b7eqtp14==4 | b7eqtp15==4) & bd7achq1==-1) | ((b7eqtp14==5 | b7eqtp15==5) & bd7achq1==-1)
* if b7eqtp-variables indicate some type of scottish qual, assume it"s just "other scottish quals".
replace bd7achq1=2 if ((b7eqtp14==6 | b7eqtp15==6) & bd7achq1==-1)
* if b7eqtp-variables indicate "other teaching qualifcation, assume diploma, not pgce.
replace bd7achq1=6 if ((b7eqtp14==13 | b7eqtp15==13) & bd7achq1==-1)

tab bd7achq1

** fix for some cases, this needs better investigation though.
	/* note from brian 2 oct 2010 - the 9 cases below under the section "fix f| some cases" are all examples of cohort members 
	saying they have quals (i.e. at least one of b7edqtp14-21 contains some info), but they don"t tell us anything about what 
	grades they got.  i take the view this means they do have the qualification, but can"t remember the grade.  so we should
	credit them with at least the "lowest" possible grade, rather than letting them slip through the net as "no quals".
	this affects not just the nine cases that were previously fixed manually.  it also affects 83 people who got an "other" 
	teaching qual (b7eqtyp14=13 | b7eqtyp15=13). */
	// BB note - this is coded as missing, unlike the note above - and seems to be accounted for in the code I add just below
	* if key=10990 bd7achq1=-1.
	* if key=13570 bd7achq1=-1.
	* if key=31220 bd7achq1=-1.
	* if key=58171 bd7achq1=-1.
	* if key=92110 bd7achq1=-1.
	* if key=105690 bd7achq1=-1.
	* if key=143240 bd7achq1=-1.
	* if key=151810 bd7achq1=-1.
	* if key=702700  bd7achq1=-1
recode bd7achq1 (-1=0) if bd7acad==0		// BB addition - I think this is what was being done in the SPSS code
label var bd7achq1 "(derived) bcs 2004: highest academic qualification cm obtained in 2004 survey"
label define bd7achq1 0 "no academic qualification" 1 "gcse d-e" 2 "other scottish quals" 3 "gcse a-c, scot st&ards/intermediate 1" ///
	4 "scot intermediate 2 / as levels | 1 a level"  5 "2+ a levels, scot higher/6th" 6 "diploma" ///
	7 "degree, pgce, other degree qual"  8 "higher degree" -1 "level not calculable"
label values bd7achq1 bd7achq1 

tab bd7achq1
tab bd7achq1 bd7acad 


**highest academic qualification reported in 2004: coded to match nvqaca00 variable in 2000 survey.
recode bd7achq1 (-1=-1) (0=0) (1=1) (2=1)(3=2)(4=2)(5=3)(6=4)(7=4)(8=5), gen(bd7anvq1)
label var bd7anvq1 "(derived) bcs 2004: highest nvq level from an academic qualification in 2004 survey"
label define bd7anvq1 0 "none"  1 "nvq1 level" 2 "nvq2 level"  3 "nvq3 level" 4 "nvq4 level" 5 "nvq5 level" -1" not applicable"
label values bd7anvq1 bd7anvq1 
tab bd7anvq1



**************************************************************************************.
**if cm obtained any vocational qualifications in 2004 since last interview.
**************************************************************************************.

recode bd7voct (-1=-1) (0=0) (1=1)(else=-1), gen(bd7anyvoc)		// Small change to make this work in Stata
	label var bd7anyvoc "(derived) bcs 2004: cm has obtained a vocational qualification since last interview"
	label define bd7anyvoc -1"not applicable" 0"no vocational qual" 1"yes, has a vocational qual"
	label values bd7anyvoc bd7anyvoc 
tab bd7anyvoc

**highest vocational qualification reported in 2004: coded to match hivoc00  variable in 2000 survey.
	** cohort members have "other vocational" quals (bd7voth) & we ask about when awarded, full-time | part-time & who paid.
	** but not what the qualification was - in the syntax below i have conservatively graded these as nvq level 1.
	** -1 is f| those cases where the level was not known so cant be computed
gen bd7vnvq1 = -1.
	replace bd7vnvq1 = 0 if (bd7anyvoc == 0) 
	replace bd7vnvq1 = 1 if (pit1==1 | rsa1 == 1 | bd7rsa == 1 | nvq1 == 1 | nvq7 == 1 | nvq8 == 1 | gnvq1 == 1 | bd7hgv ==1 | bd7voth==1 | bd7rta==1) 
	replace bd7vnvq1 = 2 if (pit2==1 | rsa2 == 1 | city1 == 1 | city2 == 1 | city5 == 1 | city6 == 1 | nvq2 ==1 | gnvq2 == 1 | btec1 == 1 | btec2 == 1 | btec5 == 1) 
	replace bd7vnvq1 = 3 if (pit3==1 | city3 == 1 | nvq3 == 1 | gnvq3 == 1 | btec3 == 1 | bd7onc == 1) 
	replace bd7vnvq1 = 4 if (pit4==1 | city4 == 1 | nvq4 == 1 | gnvq4 == 1 | bd7otht == 1 | btec4 == 1 | hnc1==1 | hnc2==1 | hnc3==1 | bd7nq == 1) 
	replace bd7vnvq1 = 5 if (nvq6 == 1 | bd7pgce == 1) 
label var bd7vnvq1 "(derived) bcs 2004: highest nvq level from a vocational qualification in 2004 survey"
label define bd7vnvq1 0"none" 1"nvq1 level" 2"nvq2 level" 3"nvq3 level" 4"nvq4 level" 5"nvq5 level" -1"level not calculable"
label values bd7vnvq1 bd7vnvq1 



***********************************************************************************************************************************.
**highest nvq level vocational | academic qualification reported in 2004: coded to match hinvq00  variable in 2000 survey.
***********************************************************************************************************************************.

gen bd7nvq1 = bd7vnvq1
	replace bd7nvq1 = bd7anvq1 if (bd7anvq1 > bd7vnvq1) 
label var bd7nvq1 "(derived) bcs 2004: highest nvq level from an academic | vocational qualification in 2004 survey"
label define bd7nvq1 0"none" 1"nvq1 level" 2"nvq2 level" 3"nvq3 level" 4"nvq4 level" 5"nvq5 level" -1"not applicable"
label values bd7nvq1 bd7nvq1 
tab bd7nvq1

// Added by BB due to differences in missing values between SPSS and Stata - these are people who gained no quals, so we just don't know about them
replace bd7nvq1 = . if  bd7acad==0 & bd7voct==0

save temp\bcs_2004_followup_edvars, replace
