// Do files - BB adapted from Kenzo 12/3/2012

////////////////////////////////////////////
////////////////////////////////////////////
use temp/bcs1986-2012, replace /*I must run the do-files separately because this is the only way I have found to keep track of 
different versions of each do-file. i.e. If I only run the 0_master.do I must name the picking_vars and data_cleaning always
under the same name and can not keep track of different versions*/

// RECODING MISSING VALUES
		#delimit ;
	note: Data cleaning. I have recoded all missing variables following Scott Long (p.171): 
		.d "Don't know"
		.n "Not applicable"
		.p "Preliminary question (lead-in question) refused"
		.r "Refused"
		.s "Skipped due to skip pattern"
		* I invented the following codes:
		.q "No questionnaire was received from this interviewee"
		.h "Not at home or dead"
		.o "Other answer"
		.a "Not answered"
		.i "Inconsistent data"
		.w "Person not found in this wave (attrition)"
		.y "Interviewee not in the panel yet (incorporated in a subsequent year)"
		;
		#delimit cr
			
// MISSINGNESS BECAUSE OF ATTRITION OR NEW INDIVIDUALS IN THE PANEL
rename merge04 merge04_ /*Had to rename because if not the merge* vars are recoded*/
rename merge00 merge00_
rename merge96 merge96_
rename merge86 merge86_

recode *04 			(*=.w) if merge04_==1
recode *00 			(*=.w) if merge00_==1 /*This works because in 2004 there were no new individuals added to the panel*/
recode *96 			(*=.w) if merge96_==1 /*Individuals that were only in 1986 and not in 1996*/
recode *86 			(*=.w) if merge86_==1 /*Individuals that were only in 1980 and not in 1986*/
recode *96  *86 *80 (*=.y) if merge00_==2 /*Individuals that were added to the panel in 2000*/
recode 		*86 *80	(*=.y) if merge96_==2 /*Individuals that were added to the panel in 1996*/
recode 		    *80	(*=.y) if merge86_==2 /*Individuals that were added to the panel in 1986*/

// 	QUESTION FOR BEN: I could rename the variables (e.g. introducing suffix R), but given how messy the names get, there's a trade-off.. 

*1980 RECODING
	recode *80 (5=.d)

*1986 RECODING
		#delimit ;
	note: 1986 Data
			-4 "not asked" into .s
			-2 (questions not responded in the questionnaire) into .a
			-1 into .q
		;
		#delimit cr
	recode *86 (-4=.s)
	recode *86 (-2=.a) /* Turn questions not responded the questionnaire (-2) into .r  */
	recode *86 (-1=.q) /* -1 into .q (meaning, "no questionnaire was received from this interviewee") */

	recode infal86 (3=.d)
		notes infal86: infal86==3 "can't say" recoded to .d
	recode infal*86 (-4=.s)
/*	recode dkview*86 (1=.d)
		Given the nature of these questions (knowledge about family's view on drinking or family drinking habits) 
		I would leave "don't know" as an admissible category within this question 
		(and not make it a missing value). Do you agree?
pause BB: YES, THAT SEEMS SENSIBLE, AT lEAST FOR THE TIME BEING (SAME GOES JUST BELOW TOO)
	recode dkal*86 (5=.d)(6=.h)*/
/*	recode tnhusprtN86 (4=.d) GIVEN THE NATURE OF THE QUESTION, I AM OPTING FOR INCLUDING "DON'T KNOW"
								AS AN ADMISSIBLE RESPONSE
		notes tnhusprtN86: infal86==4 "can't say" recoded to .d */
	recode tnhusprtN86 (5=.o)
		notes tnhusprtN86: infal86==5 "other answer" recoded to .o
	/*recode drgfl*86 (6=.d) 
		notes drgflgluN86: drgfl*==6 "can't say" recoded to .d	
		notes drgfluppN86: drgfl*==6 "can't say" recoded to .d	
		notes drgfldowN86: drgfl*==6 "can't say" recoded to .d	
		notes drgflcanN86: drgfl*==6 "can't say" recoded to .d	
		notes drgfllsdN86: drgfl*==6 "can't say" recoded to .d	
		notes drgflcocN86: drgfl*==6 "can't say" recoded to .d	
		notes drgflsemN86: drgfl*==6 "can't say" recoded to .d	
		notes drgflherN86: drgfl*==6 "can't say" recoded to .d	
			"CAN'T SAY" DOES CONVEY SOME INFO (MAYBE A BIT SIMILAR TO "NOT SURE"
			HENCE, I PREFER TO LEAVE IT AS ADMISSIBLE ANSWER. BEN, DO YOU AGREE? */
/*	recode  behavprB86 (3=.d) 
		notes  behavprB86: behavprB86==3 "not known" recoded to .d
	recode psy*86 (3=.d)
		notes psycmalB86: var==3 "not known" recoded to .d
		notes psydeprB86 : var==3 "not known" recoded to .d
		notes psyaggrB86: var==3 "not known" recoded to .d
		notes psyanorB86: var==3 "not known" recoded to .d
		notes psychosB86: var==3 "not known" recoded to .d
		notes psyneurB86: var==3 "not known" recoded to .d
		notes psysuicB86: var==3 "not known" recoded to .d
		"NOT KNOWN" DOES CONVEY SOME INFO (MOTHER DOES NOT KNOW WHETHER TEEN HAD BEHAV PROBS)
			HENCE, I PREFER TO LEAVE IT AS ADMISSIBLE ANSWER. BEN, DO YOU AGREE? */
	recode  pqtrdapp86 pqolevel86 pqalevel86 pqnurse86 pqteach86 pqdegree86 pqother86 pqnoqual86 pqnotkno86 (4=.r)
		notes pqtrdapp86: var==4 "no response" recoded to .a
		notes pqolevel86: var==4 "no response" recoded to .a
		notes pqalevel86: var==4 "no response" recoded to .a
		notes pqnurse86: var==4 "no response" recoded to .a
		notes pqteach86: var==4 "no response" recoded to .a
		notes pqdegree86: var==4 "no response" recoded to .a
		notes pqother86: var==4 "no response" recoded to .a
		notes pqnoqual86: var==4 "no response" recoded to .a
		notes pqnotkno86: var==4 "no response" recoded to .a
	
* 1996 RECODING
		#delimit ;
	note: 1996 Data
			-3 "Not stated" into .a
			-7 "Out of range" into .o
			-8 "Inappropriate response" into .o;
		#delimit cr
	recode *96 (-3=.a) (-7 -8=.o)
	/* I tabbed tab  unempnp96 if  fteducst96==1 and most full-time students
		declared that they had been unemployed at some point. Hence, I discarded
		considering all FT students as .s due to the skipping pattern.
		The same happened for netpay96*/
	recode alc*wk96 (*=.s) if  alcfreq96==6 /*Those who declared they never drink should have .s in no of pints*/

* 2000 RECODING
/*	recode  drinks00 (8=.d)
		notes drinks00: (8=.d)
			"DON'T KNOW" CONVEYS SOME INFO (INTERVIWEE DOES NOT KNOW HER DRINKING PATTERNS? STRANGE).
			HENCE, I PREFER TO LEAVE IT AS ADMISSIBLE ANSWER. BEN, DO YOU AGREE? */
	recode  drinks00 othdrink00	(9=.a)(8=.d)
		notes drinks00:(9=.a)(8=.d)
		notes othdrink00:(9=.a)(8=.d)
	recode  beer00 spirits00 wine00 sherry00 pops00 (999=.a)(998=.d)
		notes beer00   :(999=.a)(998=.d)
		notes spirits00:(999=.a)(998=.d)
		notes wine00   :(999=.a)(998=.d)
		notes sherry00 :(999=.a)(998=.d)
		notes pops00   :(999=.a)(998=.d)
	recode cage*00 		(9=.a) 
		note: cage*00 data cleaning: cage* (9=.a)
	recode  lifesat100 	 (98=.d)(99=.a)
		notes lifesat100:(98=.d)(99=.a)
*	Ben: NOTE THAT "DON'T KNOW" CONVEYS SOME INFO (INTERVIWEE DOES NOT WHETHER SHE IS SATISFIED IN LIFE? STRANGE).
		
* 2004 RECODING
	recode *04 (-9=.r)(-8=.d)(-7=.)(-2=.i)(-1=.n) /*Ben, maybe we could collapse categories .s and "Not applicable" missing data. At least in 2004 wer are not able to tell apart both reasons. Do you agree?*/
		note: 2004 data cleaning: (-9=.r)(-8=.d)(-7=.)(-2=.i)(-1=.n)

* 2012 RECODING
	recode ms12-chour912 smokig12-scq3612 (-9=.r)(-8=.d)(-1=.n)
		
		
* FINISHING OFF		
save temp\bcs1986-2012_recoded_miss, replace




