// This has been heavily edited since Kenzo's version, to extend to 2012 and correct errors (though much of this was instead done in 2_data_cleaning_v8)

*use temp\bcs1986-2012_recoded_miss, replace

*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
** INCOME/PAY
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************


//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
// 1996
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

* GEN NET PAY PER WEEK VARIABLE
	gen netpaywk96=  netpay96*35 if  netpaypr96==1
	replace netpaywk96=  netpay96*5 if  netpaypr96==2
	replace netpaywk96=  netpay96 if  netpaypr96==3
	replace netpaywk96=  netpay96*12/52 if  netpaypr96==4
	replace netpaywk96=  netpay96/52 if  netpaypr96==5
drop netpay96 netpaypr96
drop netpaywk96 	// This isn't needed - there's a supplied dv in the dataset


	
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
// 2000
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

** GEN OF BENEFITS VARIABLES
	* Loop over benefits - each number refers to a different benefit, from 1 (SSP) to 25 (other benefit)
		clonevar benamt100 = benamt00
		clonevar benprd100 = benprd00
		forvalues i=1(1)25 {
			gen benamtw`i'00=.
				replace benamtw`i'00=benamt`i'00			if benprd`i'00==1
				replace benamtw`i'00=benamt`i'00/2		   	if benprd`i'00==2
				replace benamtw`i'00=benamt`i'00/3		   	if benprd`i'00==3
				replace benamtw`i'00=benamt`i'00/4		   	if benprd`i'00==4
				replace benamtw`i'00=benamt`i'00*12/52	   	if benprd`i'00==5
				replace benamtw`i'00=benamt`i'00*12/(52*2) 	if benprd`i'00==6
				replace benamtw`i'00=benamt`i'00*12/(52*3) 	if benprd`i'00==7
				replace benamtw`i'00=benamt`i'00*12/(52*6) 	if benprd`i'00==8
				replace benamtw`i'00=benamt`i'00/52		   	if benprd`i'00==9
				replace benamtw`i'00=.d						if benprd`i'00==98 | benamt`i'00==99998	// don't knows - added BB 2014
				replace benamtw`i'00=.r						if benprd`i'00==99 | benamt`i'00==99999	// not answered - added BB 2014
			label variable benamtw`i'00 "weekly pay - benefit number `i'"
		/**/				}
	* EDITING WHERE BENEFIT AMOUNTS ARE IMPLAUSIBLE
		/* Previously Kenzo did:
			* Turn to .a those households with statutory sick pay per week >1000 (2010 payment: 86 per week)	
			* Turn to .a those households with child benefit per week >200 (would need to have almost 14 children at 2010 rates)	
			* Turn to .a those households with jobseeker's allwance per week >200 (the cap for couples is at 111)	
			* Turn to .a those households with income support per week >500 (the cap for 25 or over is $67)	
			And then the rest for 1000+ - but for consistency with later years, I've changed it to this - benefits haven't changed hugely in value over this period */
		* Turn to .a those households with oter benefits per week >1000
		forvalues i = 1/25	{
			replace benamtw`i'00=.i if benamtw`i'00>1000 & ~missing(benamtw`i'00)
		/**/				}
	* Replacing missing values with weekly averages, where this seems reasonable (often gaps are where there are no missing values)
		foreach i in 1 2 3 4 	6 7 8 9 10 11 	13 14 15 16 17 18 19 	23 	{
			sum benamtw`i'00
			local meanben = r(mean)
			replace benamtw`i'00 = `meanben' 				if benamtw`i'00==.d | benamtw`i'00==.r | benamtw`i'00==.i
		/**/														}
	* Adding these into a benefit income total
		gen benamtot00=0
		forvalues i=1(1)25 	{
			replace benamtot00 = benamtot00 + benamtw`i'00 if ~missing(benamtw`i'00)
		/**/				}
		
		
		
* GEN OF EARNINGS VARIABLES
* Looping over cohort member (c) and partner (p) to turn this into weekly amounts
foreach i in c p	{
	gen 		`i'netpayw00=.
		replace `i'netpayw00=`i'netpay00			if `i'netprd00==1 | `i'netpred00==1
		replace `i'netpayw00=`i'netpay00/2 			if `i'netprd00==2
		replace `i'netpayw00=`i'netpay00/4 			if `i'netprd00==3
		replace `i'netpayw00=`i'netpay00*(12/52)	if `i'netprd00==4 | `i'netpred00==4
		replace `i'netpayw00=`i'netpay00/52 		if `i'netprd00==5
		replace `i'netpayw00=`i'netpay00/3 			if `i'netprd00==6 & `i'netpred00==6
		replace `i'netpayw00=`i'netpay00/5 			if `i'netprd00==6 & `i'netpred00==7
		replace `i'netpayw00=`i'netpay00/6			if `i'netprd00==6 & `i'netpred00==8
		replace `i'netpayw00=`i'netpay00/7			if `i'netprd00==6 & `i'netpred00==9
		replace `i'netpayw00=`i'netpay00/13			if `i'netprd00==6 & `i'netpred00==15
		replace `i'netpayw00=`i'netpay00*(6/52)		if `i'netprd00==6 & `i'netpred00==11	
		replace `i'netpayw00=.d						if `i'netprd00==6 & `i'netpred00>=17	// other periods
		replace `i'netpayw00=.d						if `i'netpay00==9999998
		replace `i'netpayw00=.r						if `i'netpay00==9999999 
	label variable `i'netpayw00 "`i' take-home [net] pay: weekly amount"
/**/				}
replace cnetpayw00 = 0 if missing(cnetpayw00) & ( econact00>=5 &  econact00<=12)	/*We assume the salary might have been zero only for non employees with a netpay-missing value because of unknown reasons*/
replace pnetpayw00 = 0 if missing(pnetpayw00) & (peconact00>=5 & peconact00<=12)	/*We assume the salary might have been zero only for non employees with a netpay-missing value because of unknown reasons*/
* Self-employed - seearn is gross, seprofit is net (but some missing data where people don't draw up profit & loss accounts: SEACCNTS00)
recode seearn00 seprofit00 (99999998=.d)(99999999=.r)
replace cnetpayw00 = seprofit00/52 	if ~missing(seprofit00)						// This is an annual figure - more accurate to assume this than to use the start/end accounting period dates, seemingly.  S/e income and earnings are exclusive, seemingly
replace cnetpayw00 = seearn00/52 	if ~missing(seearn00) & missing(cnetpayw00)
* Other jobs - separate variable
recode ojnetpw00 (99998=.d)(99999=.r), copyrest gen(ojnetpwR00)	
drop ojnetpw00 

	
** GEN OF OTHER INCOME VARIABLES (missed out by Kenzo), based on benefits syntax - only 80 people, but still needs doing
	* Loop over income sources
		clonevar incamt100 = incamt00
		clonevar incprd100 = incprd00
		forvalues i=1(1)12 {
			gen incamtw`i'00=.
				replace incamtw`i'00=incamt`i'00			if incprd`i'00==1
				replace incamtw`i'00=incamt`i'00/2		   	if incprd`i'00==2
				replace incamtw`i'00=incamt`i'00/3		   	if incprd`i'00==3
				replace incamtw`i'00=incamt`i'00/4		   	if incprd`i'00==4
				replace incamtw`i'00=incamt`i'00*12/52	   	if incprd`i'00==5
				replace incamtw`i'00=incamt`i'00*12/(52*2) 	if incprd`i'00==6
				replace incamtw`i'00=incamt`i'00*12/(52*3) 	if incprd`i'00==7
				replace incamtw`i'00=incamt`i'00*12/(52*6) 	if incprd`i'00==8
				replace incamtw`i'00=incamt`i'00/52		   	if incprd`i'00==9
				replace incamtw`i'00=.d						if incprd`i'00==98 | incamt`i'00==99998	// don't knows - added BB 2014
				replace incamtw`i'00=.r						if incprd`i'00==99 | incamt`i'00==99999	// not answered - added BB 2014
			label variable incamtw`i'00 "weekly pay - income source number `i'"
		/**/				}
	* Adding these into a other income total
		egen incamtot00 = rowtotal(incamtw*00)
		egen incnmiss00 = rownonmiss(incamtw*00)
		replace incamtot00 = . if incnmiss00==0
		drop incnmiss00
		
		
** EQUIVALISING
	// Firstly need to back to another dataset
	save temp\bcs1984-2012_2_new_vars, replace
	use bcsid age2 age3 age4 age5 age6 age7 age8 age9 age10 using original_datafiles/bcs2000, replace
	reshape long age, i(bcsid) j(person) /*for identifying children and adults by age*/
	* CALCULATE PER CAPITA EXPENDITURE USING MODIFIED OECD SCALE (1st adult=1; Other members older than 14.5y=.5; Other kids less than 14.5=.3)		
	recode age* (998=.d) (999=.a) 
	gen child = age < 15 if age < .
	gen oecdnadult=.3 if child==1
		replace oecdnadult=.5 if child==0
	bys bcsid: egen tadultm1 = total(oecdnadult) /*adding all equivalent adults*/
	gen tadult00=  tadultm1+1 /*adding the head of household (was not included within kept variables--was "age"*/
		label variable tadult00 "total equivalent adults - OECD modified scale"
	* CALCULATING NUMBER OF CHILDREN 0-5 AND 6-17 YEARS OLD
	gen child0_5 =  age>=0 & age<=5  if age<.
		bys bcsid: egen tchild0_500 = total(child0_5) /*adding all children 0-5 per hh*/
			label variable tchild0_500 "total children 0-5 years per hh"
	gen child6_17 = age> 5 & age<=17 if age<.
		bys bcsid: egen tchild6_1700 = total(child6_17) /*adding all children 0-5 per hh*/
			label variable tchild6_1700 "total children 6-17 years per hh"
	* SAVE DATASET
	keep bcsid tadult00 tchild0_500 tchild6_1700
	duplicates drop bcsid, force /*erasing redundant rows*/
	sum  tadult00, det
	save temp\bcs2000_total_adults, replace
	* MERGING
	use temp\bcs1984-2012_2_new_vars, clear
		merge m:m bcsid using temp\bcs2000_total_adults, gen(mergenumbad00)
		drop if mergenumbad00==2	// merge==1 are people who gave no responses in 2000, but who might give responses in other years!
		drop merge*
		
		
** COMBINING ALL OF THESE & TIDYING UP
	egen netincpw00 = rowtotal(cnetpayw00 pnetpayw00 ojnetpwR00 incamtot00 benamtot00) 
	replace netincpw00 = . if econact00==.w | cnetpayw00==.d | cnetpayw00==.r | pnetpayw00==.d | pnetpayw00==.r 		// Refusals are only about pay (other sources are considered lesser sources, except benefits for which we impute avg amounts per benefit)
	label variable netincpw00 "total hhold net income (p/week), UNEQUIVALISED" 
	* CALCULATING PER CAPITA EXPENDITURE FOR 2000
	gen netpcinc00= netincpw00/ tadult00 /*dividing (total income + benefits) by total equivalent adults*/
	label variable  netpcinc00 "net hhold p/capita net income (OECD mod scale)"
	* Tidying up
	sum netincpw00 netpcinc00 ?netpayw00 ojnetpwR00 incamtot00 benamtot00
	drop bencod0100-benprd2500 benamt100-benamtw2500 ?netpay00 ?netprd00 ?netpred00 incamtw*00 incamt00-incprd1200 incamt100-incamtw1200 seprofit00 seearn00 seaccnts00 
		
	
	
	
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
// 2004 
// THIS IS AS IN 2000, BUT CHANGING THE VAR NAMES TO WHAT WAS USED IN 2004 (somehow similar)
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

** GEN OF BENEFITS VARIABLES
	* Loop over benefits - each number refers to a different benefit, from 1 (SSP) to 25 (other benefit)
		clonevar bamt104 = bamt04
		clonevar bprd104 = bprd04
		forvalues i=1(1)26 {
			gen benamtw`i'04=.
				replace benamtw`i'04=bamt`i'04				if bprd`i'04==1
				replace benamtw`i'04=bamt`i'04/2		   	if bprd`i'04==2
				replace benamtw`i'04=bamt`i'04/3		   	if bprd`i'04==3
				replace benamtw`i'04=bamt`i'04/4		   	if bprd`i'04==4
				replace benamtw`i'04=bamt`i'04*12/52	   	if bprd`i'04==5
				replace benamtw`i'04=bamt`i'04*12/(52*2) 	if bprd`i'04==6
				replace benamtw`i'04=bamt`i'04*12/(52*3) 	if bprd`i'04==7
				replace benamtw`i'04=bamt`i'04*12/(52*6) 	if bprd`i'04==8
				replace benamtw`i'04=bamt`i'04/52		   	if bprd`i'04==9
				replace benamtw`i'04=.d						if bprd`i'04==-8 | bprd`i'04==10 | bamt`i'04==-8 // don't knows - added BB 2014
				replace benamtw`i'04=.r						if bprd`i'04==-9 | bamt`i'04==-9 // not answered - added BB 2014
			label variable benamtw`i'04 "weekly pay - benefit number `i'"
		/**/				}
	* EDITING WHERE BENEFIT AMOUNTS ARE IMPLAUSIBLE
		/* Previously Kenzo did the same as for 2000 above - but for consistency with later years, I've changed it to this - benefits haven't changed hugely in value over this period */
		* Turn to .a those households with oter benefits per week >1000
		forvalues i = 1/26	{
			replace benamtw`i'04=.i if benamtw`i'04>1000 & ~missing(benamtw`i'04)
		/**/				}
	* Replacing missing values with weekly averages, where this seems reasonable - not NI credits or other
		forvalues i = 1/24 {
			sum benamtw`i'04
			local meanben = r(mean)
			replace benamtw`i'04 = `meanben' 				if benamtw`i'04==.d | benamtw`i'04==.r | benamtw`i'04==.i
		/**/				}
	* Adding these into a benefit income total
		gen benamtot04=0
		forvalues i=1(1)26 	{
			replace benamtot04 = benamtot04 + benamtw`i'04 if ~missing(benamtw`i'04)
		/**/				}

			
/////////////////////////////////////
// GEN OF INCOME VARIABLES
* GEN OF EARNINGS VARIABLES
* Looping over cohort member (c) and partner (p) to turn this into weekly amounts - no details given where period is 'other'
foreach i in c p	{
	gen 		`i'netpayw04=.
		replace `i'netpayw04=`i'netpy04				if `i'netpd04==1 
		replace `i'netpayw04=`i'netpy04/2 			if `i'netpd04==2
		replace `i'netpayw04=`i'netpy04/4 			if `i'netpd04==3
		replace `i'netpayw04=`i'netpy04*(12/52)		if `i'netpd04==4 
		replace `i'netpayw04=`i'netpy04/52 			if `i'netpd04==5
		replace `i'netpayw04=.d						if `i'netpd04==6  | `i'netpy04==-8
		replace `i'netpayw04=.r						if `i'netpy04==-9
		replace `i'netpayw04=.n						if `i'netpy04==-1	// 'not applicable' - nearly entirely (n=5 exceptions) those not working as employees
	label variable `i'netpayw04 "`i' take-home [net] pay: weekly amount"
/**/				}
replace cnetpayw04 = 0 if missing(cnetpayw04) & ( ecact04>=5 &  ecact04<=11)	/*We assume the salary might have been zero only for non employees with a netpay-missing value because of unknown reasons*/
replace pnetpayw04 = 0 if missing(pnetpayw04) & (pecact04>=5 & pecact04<=11)	/*We assume the salary might have been zero only for non employees with a netpay-missing value because of unknown reasons*/
* Self-employed - seearn is gross, seprofit is net (but some missing data where people don't draw up profit & loss accounts: SEACTS04)
recode seearn04 seprit04 (-8=.d)(-9=.r)(-1=.n)
replace cnetpayw04 = seprit04/52 	if ~missing(seprit04)						// This is an annual figure - more accurate to assume this than to use the start/end accounting period dates, seemingly.  S/e income and earnings are exclusive, seemingly
replace cnetpayw04 = seearn04/52 	if ~missing(seearn04) & missing(cnetpayw04)
* Other jobs - separate variable
recode ojnetw04 (-8=.d)(-9=.r)(-1=.n), copyrest gen(ojnetpwR04)	
drop ojnetw04

	
** GEN OF OTHER INCOME VARIABLES (missed out by Kenzo), based on benefits syntax - only a few people, but still needs doing
	* Loop over income sources
		clonevar iamt104 = iamt04
		clonevar iprd104 = iprd04
		forvalues i=1(1)12 {
			gen iamtw`i'04=.
				replace iamtw`i'04=iamt`i'04			if iprd`i'04==1
				replace iamtw`i'04=iamt`i'04/2		   	if iprd`i'04==2
				replace iamtw`i'04=iamt`i'04/3		   	if iprd`i'04==3
				replace iamtw`i'04=iamt`i'04/4		   	if iprd`i'04==4
				replace iamtw`i'04=iamt`i'04*12/52	   	if iprd`i'04==5
				replace iamtw`i'04=iamt`i'04*12/(52*2) 	if iprd`i'04==6
				replace iamtw`i'04=iamt`i'04*12/(52*3) 	if iprd`i'04==7
				replace iamtw`i'04=iamt`i'04*12/(52*6) 	if iprd`i'04==8
				replace iamtw`i'04=iamt`i'04/52		   	if iprd`i'04==9
				replace iamtw`i'04=.d					if iprd`i'04==-8 | iamt`i'04==-8 // don't knows - added BB 2014
				replace iamtw`i'04=.r					if iprd`i'04==-9 | iamt`i'04==-9 // not answered - added BB 2014
			label variable iamtw`i'04 "weekly pay - income source number `i'"
		/**/				}
	* Adding these into a other income total
		egen incamtot04 = rowtotal(iamtw*04)
		egen incnmiss04 = rownonmiss(iamtw*04)
		replace incamtot04 = . if incnmiss04==0
		drop incnmiss04


** EQUIVALISING
	// Firstly need to back to another dataset
	save temp\bcs1984-2012_3_new_vars, replace
	use bcsid b7rage12 b7rage13 b7rage14 b7rage15 b7rage16 b7rage17 b7rage18 b7rage19 b7rage20 using original_datafiles/bcs_2004_followup, replace
	renvars b7rage12 b7rage13 b7rage14 b7rage15 b7rage16 b7rage17 b7rage18 b7rage19 b7rage20, predrop(3)
	recode age* (-9=.r)(-8=.d)(-7=.)(-2=.i)(-1=.n) /*Ben, maybe we could collapse categories .s and "Not applicable" missing data. At least in 2004 wer are not able to tell apart both reasons. Do you agree?*/
		note: 2004 data cleaning: (-9=.r)(-8=.d)(-7=.)(-2=.i)(-1=.n)
	* CALCULATE PER CAPITA EXPENDITURE USING MODIFIED OECD SCALE (1st adult=1; Other members older than 14.5y=.5; Other kids less than 14.5=.3)		
	reshape long age, i(bcsid) j(person) /*for identifying children and adults by age*/
	recode age* (998=.d) (999=.a) 
	gen child = age < 15 if age < .
	gen oecdnadult=.3 if child==1
		replace oecdnadult=.5 if child==0
	bys bcsid: egen tadultm1 = total(oecdnadult) /*adding all equivalent adults*/
	gen tadult04=  tadultm1+1 /*adding the head of household (was not included within kept variables--was "age"*/
		label variable tadult04 "total equivalent adults - OECD modified scale"
	* CALCULATING NUMBER OF CHILDREN 0-5 AND 6-17 YEARS OLD
	gen child0_5 =  age>=0 & age<=5  if age<.
		bys bcsid: egen tchild0_504 = total(child0_5) /*adding all children 0-5 per hh*/
			label variable tchild0_504 "total children 0-5 years per hh"
	gen child6_17 = age> 5 & age<=17 if age<.
		bys bcsid: egen tchild6_1704 = total(child6_17) /*adding all children 0-5 per hh*/
			label variable tchild6_1704 "total children 6-17 years per hh"
	* SAVE DATASET
	keep bcsid tadult04 tchild0_504 tchild6_1704
	duplicates drop bcsid, force /*erasing redundant rows*/
	sum  tadult04, det
	save temp\bcs2004_total_adults, replace
	* MERGING
	use temp\bcs1984-2012_3_new_vars, clear
		merge m:m bcsid using temp\bcs2004_total_adults, gen(mergenumbad04)
		drop if mergenumbad04==2
		drop merge*
		

		
** COMBINING ALL OF THESE & TIDYING UP
	egen netincpw04 = rowtotal(cnetpayw04 pnetpayw04 ojnetpwR04 incamtot04 benamtot04) 
	replace netincpw04 = . if ecact04==.w | cnetpayw04==.d | cnetpayw04==.r | pnetpayw04==.d | pnetpayw04==.r 		// Refusals are only about pay (other sources are considered lesser sources, except benefits for which we impute avg amounts per benefit)
	label variable netincpw04 "total hhold net income (p/week), UNEQUIVALISED" 
	* CALCULATING PER CAPITA EXPENDITURE FOR 2004
	gen netpcinc04= netincpw04/ tadult04 /*dividing (total income + benefits) by total equivalent adults*/
	label variable  netpcinc04 "net hhold p/capita net income (OECD mod scale)"
	* Tidying up
	drop bamt04-bprd2604 bamt104-benamtw2604 iamt04-iprd1204 iamt104-iamtw1204 ?netpy04 ?netpd04 seprit04 seearn04 seacts04	
	sum netincpw00 netpcinc00 ?netpayw00 ojnetpwR00 incamtot00 benamtot00 tadult00
	sum netincpw04 netpcinc04 ?netpayw04 ojnetpwR04 incamtot04 benamtot04 tadult04

	


	
	
	
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
// 2012 
// THIS IS AS IN 2000, BUT CHANGING THE VAR NAMES TO WHAT WAS USED IN 2004 (somehow similar)
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

** GEN OF BENEFITS VARIABLES
	* Loop over benefits - each number refers to a different benefit, from 1 to 30
		forvalues i=1(1)30 {
			gen benamtw`i'12=.
				replace benamtw`i'12=bena`i'12				if benp`i'12==1
				replace benamtw`i'12=bena`i'12/2			if benp`i'12==2
				replace benamtw`i'12=bena`i'12/3			if benp`i'12==3
				replace benamtw`i'12=bena`i'12/4			if benp`i'12==4
				replace benamtw`i'12=bena`i'12*1*(12/52)	if benp`i'12==5
				replace benamtw`i'12=bena`i'12*2*(12/52)	if benp`i'12==7
				replace benamtw`i'12=bena`i'12*3*(12/52)	if benp`i'12==13		// Labelling is because this is 13wks
				replace benamtw`i'12=bena`i'12*6*(12/52)	if benp`i'12==26		// Labelling is because this is 26wks
				replace benamtw`i'12=bena`i'12 /52			if benp`i'12==52		// Labelling is because this is 52wks
				replace benamtw`i'12=bena`i'12*(8/52)		if benp`i'12==8
				replace benamtw`i'12=bena`i'12*(9/52)		if benp`i'12==9
				replace benamtw`i'12=bena`i'12*(10/52)		if benp`i'12==10
				replace benamtw`i'12=.						if bena`i'12==-1 | benp`i'12==-1 | benp`i'12==99	// people who don't claim this benefit, or people's whose payment period is 'na'
				replace benamtw`i'12=.d						if bena`i'12==-8 | benp`i'12==-8 | (benp`i'12>=90 & benp`i'12<=96)
				replace benamtw`i'12=.r						if bena`i'12==-9 | benp`i'12==-9
			label variable benamtw`i'12 "weekly payment - benefit number `i'"
		/**/				}
	* EDITING WHERE BENEFIT AMOUNTS ARE IMPLAUSIBLE
		* Turn to .a those households with oter benefits per week >1000 - only applies to 4 cases (2 CB, 2 WTC)
		forvalues i = 1/30	{
			replace benamtw`i'12=.i if benamtw`i'12>1000 & ~missing(benamtw`i'12)
		/**/				}
	* Replacing missing values with weekly averages, where this seems reasonable
		foreach i in 1 2 3 4 5 6 7 8 9 10 11 12 	14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 	{
			sum benamtw`i'12
			local meanben = r(mean)
			replace benamtw`i'12 = `meanben' 				if benamtw`i'12==.d | benamtw`i'12==.r | benamtw`i'12==.i
		/**/																							}
	* Adding these into a benefit income total
		gen benamtot12=0
		forvalues i=1(1)30 	{
			replace benamtot12 = benamtot12 + benamtw`i'12 	if ~missing(benamtw`i'12)
		/**/				}
		

/////////////////////////////////////
// GEN OF INCOME VARIABLES
* GEN OF EARNINGS VARIABLES
* Looping over cohort member (c) and partner (p) to turn this into weekly amounts - no details given where period is 'other'
foreach i in c p	{
	gen 		`i'netpayw12=.
		replace `i'netpayw12=`i'neta12				if `i'netp12==1 
		replace `i'netpayw12=`i'neta12/2 			if `i'netp12==2
		replace `i'netpayw12=`i'neta12/3 			if `i'netp12==3
		replace `i'netpayw12=`i'neta12/4 			if `i'netp12==4
		replace `i'netpayw12=`i'neta12*(12/52)		if `i'netp12==5 
		replace `i'netpayw12=`i'neta12*(6/52)		if `i'netp12==7
		replace `i'netpayw12=`i'neta12*8/52 		if `i'netp12==8
		replace `i'netpayw12=`i'neta12*9/52 		if `i'netp12==9
		replace `i'netpayw12=`i'neta12*10/52 		if `i'netp12==10
		replace `i'netpayw12=`i'neta12*4/52 		if `i'netp12==13
		replace `i'netpayw12=`i'neta12*2/52 		if `i'netp12==26
		replace `i'netpayw12=`i'neta12/52 			if `i'netp12==52
		replace `i'netpayw12=.d						if (`i'netp12>=90 & `i'netp12<=99)  | `i'neta12==-8 | `i'netp12==-8
		replace `i'netpayw12=.r						if `i'neta12==-9 | `i'netp12==-9
		replace `i'netpayw12=.n						if `i'neta12==-1	// 'not applicable' - nearly entirely those not working as employees
	label variable `i'netpayw12 "`i' take-home [net] pay: weekly amount"
/**/				}
replace cnetpayw12 = 0 if missing(cnetpayw12) & ( econact12>=5 &  econact12<=11)	/*We assume the salary might have been zero only for non employees with a netpay-missing value because of unknown reasons*/
replace pnetpayw12 = 0 if missing(pnetpayw12) & (peconact12>=5 & peconact12<=11)	/*We assume the salary might have been zero only for non employees with a netpay-missing value because of unknown reasons*/
* Self-employed - seearn is gross, seprofit is net (but some missing data where people don't draw up profit & loss accounts: SEACTS04)
recode sepa12 pxts12 (-8=.d)(-9=.r)(-1=.n)(-1500=0)			// -1500 is a reasonable profit/loss account, but sensible just to treat this as 'zero earnings' here
replace cnetpayw12 = sepa12/52 	if ~missing(sepa) & missing(cnetpayw12)						// This is an annual figure - more accurate to assume this than to use the start/end accounting period dates, seemingly.  S/e income and earnings are exclusive, seemingly
*PARTNER'S SELF-EMPLOYMENT IGNORED FOR COMPARABILITY WITH EARLIER WAVES: replace pnetpayw04 = pxts12/52 	if ~missing(pxts12) & missing(cnetpayw12)
* Second job is now done differently, so needs the syntax below
gen 		sjbpayw12=.
	replace sjbpayw12=sjua12				if sjup12==1 
	replace sjbpayw12=sjua12/2 				if sjup12==2
	replace sjbpayw12=sjua12/3 				if sjup12==3
	replace sjbpayw12=sjua12/4 				if sjup12==4
	replace sjbpayw12=sjua12*(12/52)		if sjup12==5 
	replace sjbpayw12=sjua12*(6/52)			if sjup12==7
	replace sjbpayw12=sjua12*8/52 			if sjup12==8
	replace sjbpayw12=sjua12*9/52 			if sjup12==9
	replace sjbpayw12=sjua12*10/52 			if sjup12==10
	replace sjbpayw12=sjua12*4/52 			if sjup12==13
	replace sjbpayw12=sjua12*2/52 			if sjup12==26
	replace sjbpayw12=sjua12/52 			if sjup12==52
	replace sjbpayw12=.d					if (sjup12>=90 & sjup12<=99)  | sjua12==-8 | sjup12==-8
	replace sjbpayw12=.r					if sjua12==-9 | sjup12==-9
	replace sjbpayw12=.n					if sjua12==-1	// 'not applicable' 
label variable sjbpayw12 "Second job for c take-home [net] pay: weekly amount"
* Other jobs
recode ease12 (-9=.r)(-8=.d)(-1=.n), gen(easeR12)
	replace easeR12 = easeR12*12/52		// Q asks about monthly income, but I'm working in weekly income
egen ojnetpw12 = rowtotal(easeR12 sjbpayw12)
	replace ojnetpw12=.r if sjbpayw12==.r | (easeR12==.r & missing(sjbpayw12))
	replace ojnetpw12=.d if sjbpayw12==.d | (easeR12==.d & missing(sjbpayw12))
	replace ojnetpw12=.  if (easeR12==.n | easeR12==.) & (sjbpayw12==.n | sjbpayw12==.)


** GEN OF OTHER INCOME VARIABLES (missed out by Kenzo), based on benefits syntax - only a few people, but still needs doing
recode inc12 (-9=.r)(-8=.d)(-1=.n), gen(incR12)
	replace incR12 = incR12*12/52
	label var incR12 "Income from other sources per WEEK (dv from inc12)"
egen pattern = concat(incc*12)
	gen incinvestonly = pattern=="010000000000"  	// This is 869 people who report investment income (introduced for 2012) but nothing else
	bysort incinvestonly: sum incR12 cnetpayw12 pnetpayw12 ojnetpw12 benamtot12
	replace incR12 = . if incinvestonly==1


** EQUIVALISING
	// Firstly need to back to another dataset
	save temp\bcs1984-2012_4_new_vars, replace
	use original_datafiles/bcs70_2012_persongrid, replace
	renvars, lower
	renvars b9g*, predrop(3)
	recode age* (-9=.r)(-8=.d)(-1=.n) // -1 = n/a because person died  
	* CALCULATE PER CAPITA EXPENDITURE USING MODIFIED OECD SCALE (1st adult=1; Other members older than 14.5y=.5; Other kids less than 14.5=.3)		
	drop if slive==0
	keep bcsid age
	bysort bcsid (age): gen person=_n
	gen child = age < 15 if age < .
	gen oecdnadult=.3 if child==1
		replace oecdnadult=.5 if child==0
	bys bcsid: egen tadultm1 = total(oecdnadult) /*adding all equivalent adults*/
	gen tadult12=  tadultm1+1 /*adding the head of household (was not included within kept variables--was "age"*/
		label variable tadult12 "total equivalent adults - OECD modified scale"
	* CALCULATING NUMBER OF CHILDREN 0-5 AND 6-17 YEARS OLD
	gen child0_5 =  age>=0 & age<=5  if age<.
		bys bcsid: egen tchild0_512 = total(child0_5) /*adding all children 0-5 per hh*/
			label variable tchild0_512 "total children 0-5 years per hh"
	gen child6_17 = age> 5 & age<=17 if age<.
		bys bcsid: egen tchild6_1712 = total(child6_17) /*adding all children 0-5 per hh*/
			label variable tchild6_1712 "total children 6-17 years per hh"
	* SAVE DATASET
	keep bcsid tadult12 tchild0_512 tchild6_1712
	duplicates drop bcsid, force /*erasing redundant rows*/
	sum  tadult12, det
	save temp\bcs2012_total_adults, replace
	* MERGING
	use temp\bcs1984-2012_4_new_vars, clear
		merge m:m bcsid using temp\bcs2012_total_adults, gen(mergenumbad12)
		drop if mergenumbad12==2
		drop merge*
				

		
** COMBINING ALL OF THESE & TIDYING UP
	egen netincpw12 = rowtotal(cnetpayw12 pnetpayw12 ojnetpw12 incR12 benamtot12) 
	replace netincpw12 = . if econact12==. | cnetpayw12==.d | cnetpayw12==.r | pnetpayw12==.d | pnetpayw12==.r 		// Refusals are only about pay (other sources are considered lesser sources, except benefits for which we impute avg amounts per benefit)
	label variable netincpw12 "total hhold net income (p/week), UNEQUIVALISED" 
	* CALCULATING PER CAPITA EXPENDITURE FOR 2012
	gen netpcinc12= netincpw12/ tadult12 /*dividing (total income + benefits) by total equivalent adults*/
	label variable  netpcinc12 "net hhold p/capita net income (OECD mod scale)"
	* Tidying up
	sum netincpw00 netpcinc00 ?netpayw00 ojnetpwR00 incamtot00 benamtot00 tadult00
	sum netincpw04 netpcinc04 ?netpayw04 ojnetpwR04 incamtot04 benamtot04 tadult04
	sum netincpw12 netpcinc12 ?netpayw12 ojnetpw12 incR12 benamtot12 tadult12
	drop sjua12-ttnpdr12 benamtw112-benamtw3012 cnet?12 incc*12 pattern incinvestonly sjbpayw12 easeR12

		
************************************************	
* At the end of section on income vars
************************************************	
drop cnetpayw?? pnetpayw?? ojnetpw*?? incamtot?? incR12 benamtot?? tadult??


		
	
	
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
** GENERATION OF TOTAL ALCOHOL UNITS
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
// 1986
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

* Assigning a 0 for those who declared that do not drink [Kenzo also did this for those who did not respond
clonevar alcshwk086= alcshwk86
	replace  alcshwk086=0 if  alcshwk86==.a  | alcshwk86==.s 
clonevar alcbrwk086= alcbrwk86
	replace  alcbrwk086=0 if  alcbrwk86==.a  | alcbrwk86==.s 
clonevar alccdwk086= alccdwk86
	replace  alccdwk086=0 if  alccdwk86==.a  | alccdwk86==.s 
clonevar alcwnwk086= alcwnwk86
	replace  alcwnwk086=0 if  alcwnwk86==.a  | alcwnwk86==.s 
clonevar alcmtwk086= alcmtwk86
	replace  alcmtwk086=0 if  alcmtwk86==.a  | alcmtwk86==.s 
clonevar alcspwk086= alcspwk86
	replace  alcspwk086=0 if  alcspwk86==.a  | alcspwk86==.s
	* We get 1800 more observations for my derivated total alcohol var than the CLS derivated one.
	* most probably, the reason is that they did not assign a 0 to those who did not answer or declared that did not drink alcohol.

* Not assigning 0 to those that do not drink (.s) and those who did not respond (.a)

* Total units of alcohol - calculated (to check whether it coincides with the built in total units)
	gen alctotun86 =  alcshwk086+ alcbrwk086*2+ alccdwk086*2+ alcwnwk086+ alcspwk086+ alcmtwk086
		label variable alctotun86 "CM total units of alcohol/week 1986"
/* Code that reproduces alctotwk86: not assigning 0 to those that do not drink (.s) and those who did not respond (.a)		// Kenzo also said that needed to doubling the contribution of beer & cider (as in Samantha Parsons 2000)to get this, but the code seems the same
	gen alctotspcd86 =  alcshwk86+ alcbrwk86*2+ alccdwk86*2+ alcwnwk86+ alcspwk86+ alcmtwk86*/
	
drop alcshwk086-alcspwk086  

	
//////////////////////////////////////////////////////////////////////////////////////////////////
/* 1996 is not taken out as I don't use it
clonevar alcshwk096= alcshwk96
	replace  alcshwk096=0 if  alcshwk96==.  | alcshwk96==.o  | alcshwk96==.s
clonevar alcbrwk096= alcbrwk96
	replace  alcbrwk096=0 if  alcbrwk96==.  | alcbrwk96==.o  | alcbrwk96==.s
clonevar alclbrwk096= alclbrwk96
	replace  alclbrwk096=0 if alclbrwk96==. | alclbrwk96==.o | alclbrwk96==.s
clonevar alccdwk096= alccdwk96
	replace  alccdwk096=0 if  alccdwk96==. |  alccdwk96==.o  | alccdwk96==.s
clonevar alclcdwk096= alclcdwk96
	replace  alclcdwk096=0 if alclcdwk96==. | alclcdwk96==.o | alclcdwk96==.s
clonevar alcwnwk096= alcwnwk96
	replace  alcwnwk096=0 if  alcwnwk96==. |  alcwnwk96==.o  | alcwnwk96==.s
clonevar alclwnwk096= alclwnwk96
	replace  alclwnwk096=0 if alclwnwk96==. | alclwnwk96==.o | alclwnwk96==.s
clonevar alcspwk096= alcspwk96
	replace  alcspwk096=0 if  alcspwk96==. |  alcspwk96==.o |  alcspwk96==.s
clonevar alcmtwk096= alcmtwk96
	replace  alcmtwk096=0 if  alcmtwk96==. |  alcmtwk96==.o |  alcmtwk96==.s
clonevar alcothwk096= alcothwk96
	replace  alcothwk096=0 if alcothwk96==. | alcothwk96==.o | alcothwk96==.s
* All weights (except for light drinks, with a null weight) from Samantha Parsons(p.225): http://www.esds.ac.uk/doc/5558%5Cmrdoc%5Cpdf%5Cuser_guide_1999-2000_vol_1_design_and_conduct_of_the_1999-2000_surveys.pdf 
gen alctotun96 =  alcshwk096+ alcbrwk096*2+ (alclbrwk096*0)+ alccdwk096+ (alclcdwk096*0)+ alcwnwk096+ (alclwnwk096*0)+ alcspwk096+ alcmtwk096+ alcothwk096
	label variable alctotun96 "CM total units of alcohol/week 1996"
drop alcshwk96-alcothwk96 alcshwk096-alcothwk096 */	
drop alc*96
	
	

	
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
// 2000 
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

* Cleaning the variables - need to be done this way for the code below
* Note that othdnk00 is a yes/no variable, it doesn't contain substantive information
foreach var in beer00 spirits00 wine00 sherry00 pops00 	{
	recode `var' (miss=0), gen(R`var')
	recode `var' (.d=-8)(.r=-9)(.a=-1), gen(A`var')
/**/													}
egen alcmiss00 = anymatch(Abeer00 Aspirits00 Awine00 Asherry00 Apops00), values(-1 -8 -9)
	replace alcmiss00 = 1 if missing(drinks00)

* Several versions of alcohol cons need doing - see OneNote
gen alctotunNEW00 = Rbeer00*1 + Rspirits00 + Rwine00*1.3 + Rsherry00 + Rpops00*1.5 
	replace alctotunNEW00 = . if alcmiss00==1
	label variable alctotunNEW00 "CM total units alc last wk 2000, NEW conversion (wine=1.3 units/glass)"
gen alctotunOLD00 = Rbeer00*1 + Rspirits00 + Rwine00     + Rsherry00 + Rpops00     
	replace alctotunOLD00 = . if alcmiss00==1
	label variable alctotunOLD00 "CM total units alc last wk 2000, OLD conversion factors"
gen alctotunCHK00 = Rbeer00*2 + Rspirits00 + Rwine00     + Rsherry00 + Rpops00     
	replace alctotunCHK00 = . if alcmiss00==1
	label variable alctotunCHK00 "CM total units alc last wk 2000, assuming beer in PINTS + OLD conversion factors"
* Comparisons
sum R*00 beer00 spirits00 wine00 sherry00 pops00 alctot*00, sep(0)


// CAGE	- Kenzo refers to a variety of other things (e.g. drkcut00) that Samantha Parsons did in SPSS, but taken out as not used here - see 4_further_cleaning for BB version of CAGE



//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
// 2004
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

* Cleaning the variables - need to be done this way for the code below
* Note that othdnk04 is a yes/no variable, it doesn't contain substantive information
foreach var in beer04 spiris04 wine04 sherry04 pops04 	{
	recode `var' (miss=0), gen(R`var')
	recode `var' (.d=-8)(.r=-9), gen(A`var')
/**/															}
egen alcmiss04 = anymatch(Abeer04 Aspiris04 Awine04 Asherry04 Apops04), values(-8 -9)
	replace alcmiss04 = 1 if missing(drinks04)

	
* Several versions of alcohol cons need doing - see OneNote
gen alctotunNEW04 = Rbeer04*1 + Rspiris04 + Rwine04*2 + Rsherry04 + Rpops04*1.5 
	replace alctotunNEW04 = . if alcmiss04==1
	label variable alctotunNEW04 "CM total units alc last wk 2004, NEW conversion factors"
gen alctotunOLD04 = Rbeer04*1 + Rspiris04 + Rwine04   + Rsherry04 + Rpops04     
	replace alctotunOLD04 = . if alcmiss04==1
	label variable alctotunOLD04 "CM total units alc last wk 2004, OLD conversion factors"
* To compare to supplied dv - as Kenzo says, this then reproduces dunit04 (the supploed dv) except for 14 cases exc. by Kenzo
replace dunit04 = 0 if drinks04>=5 & drinks04<=7
* Comparisons
sum R*04 beer04 spiris04 wine04 sherry04 pops04 alctot*04 dunit04, sep(0)
sum alctotunCHK0? alctotunOLD0? if ~missing(alctotunOLD00, alctotunOLD04), sep(0)	// Checking beer consumption in 2000 vs. 2004 - see notes
sum beer00 beer04 				if ~missing(beer00, beer04), sep(0)


		
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
// 2012
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
	
* Cleaning the variables - need to be done this way for the code below
foreach var in beern12 beers12 spiris12 sherry12 alcopp12 wings412 wine12 winebt12 winlag12 winstg12 winsmg12	{
	recode `var' (miss=0), gen(R`var')
	recode `var' (.d=-8)(.r=-9), gen(A`var')
/**/																									}
drop Rwings412 Rwine12
egen alcmiss12 = anymatch(Abeern12 Abeers12 Aspiris12 Asherry12 Aalcopp12 Awine12 Awinebt12 Awinlag Awinstg Awinsmg), values(-8 -9)
	replace alcmiss12 = 1 if wings412==1 & missing(Rwinebt12)

	
* Several versions of alcohol cons need doing - see OneNote
gen alctotunNEW12 = Rbeern12*2 + Rbeers12*4 + Rspiris12 + Rsherry12 + Ralcopp12*1.5 + Rwinebt12*1.5 + Rwinlag*3 + Rwinstg*2 + Rwinsmg*1.5
	replace alctotunNEW12 = . if alcmiss12==1 | missing(drnk0112)
	label variable alctotunNEW12 "CM total units alc last wk 2012, NEW conversion factors"
gen alctotunOLD12 = Rbeern12*2 + Rbeers12*3 + Rspiris12 + Rsherry12 + Ralcopp12*1   + Rwinebt12*1   + Rwinlag*1 + Rwinstg*1 + Rwinsmg*1
	replace alctotunOLD12 = . if alcmiss12==1 | missing(drnk0112)
	label variable alctotunOLD12 "CM total units alc last wk 2012, OLD conversion factors"
sum R*12 alctot*12

* Checking if it's worth imitating 2000 and 2004 by excluding those who drink <monthly - the answer is 'no' (see notes)
bysort scq3212: sum alctotunNEW12
clonevar TEST1 = alctotunNEW12 if ~missing(scq3212)
	clonevar TEST2 = TEST1
	replace TEST2 = 0 if (scq3212==1 | scq3212==2) & ~missing(alctotunNEW12)
	clonevar TEST3 = TEST1
	replace TEST3 = 0 if (scq3212==1			 ) & ~missing(alctotunNEW12)
sum TEST1 TEST2 TEST3
compare TEST1 TEST2
compare TEST1 TEST3

* Checks
sum R*12 alctot*12
sum alctotunNEW12 nualc12 if ~missing(nualc12)		// These are similar but not the same - >300 units treated as missing
sum alctotunNEW* alctotunOLD*
sum alctotunNEW* alctotunOLD* if ~missing(alctotunNEW00, alctotunNEW04, alctotunNEW12)
sum beer?? beer??? spiris?? spirits?? sherry?? pops?? alcopp??, sep(0)
sum wine?? winebt12 winlag12 winstg12 winsmg12, sep(0)
// And specifically for 2012
sum beern12 beers12 alctotunNEW12

// Finishing off
drop R* A* alctotunCHK00 beer00-othdrink00 dunit04 beer04-othdnk04	drnk0112-alcopp12 alcmiss?? TEST? nualc12
save temp\bcs1986-2012-incpcapita+alcohol, replace

