//////////////////////////////////////////////////
// GLOBALS FOR ALCOHOL FACTOR ANALYSIS
// This was previously part of a larger list of globals
// but this was unnecesary and confusing - changed 24/4/2014
//////////////////////////////////////////////////

/* B suffixes are to remove the factor variables notation; S suffixes are for reduced varlists for pasimony */

**************************************
** IVs 1: Attitudes ******************
**************************************

**GLOBALS: for creating the alcohol factor scales**
/* HAD refers to Have a Drink questionnaire; FOW refers to Friends & The Outside World questionnaire */
global alc_expectations_HAD		"nopbnofn86 dktpwrld86 dkhlpshy86 dkenjoy86 dkflease86 dkattrct86 dkfriend86"
global alc_expectations_FOW		"drpeconfid86 drpefrndly86 drpehappy86 drpelesshy86 drpenone86 drpenoprob86 drpesexy86" // Vars supplied by Kenzo and added by BB in July 2013
	global alc_expectations			"${alc_expectations_HAD} ${alc_expectations_FOW}"
global alc_perceived_harm_FOW 	"unpalnon86 unpaldep86 unpalslp86 unpalill86 unpalsck86 unpalhdc86 unpalabu86 unpalvio86 unpaloth86"
global alc_perceived_harm_FOW	"${alc_perceived_harm_FOW} drafbrkthn86 drafdrvcar86 draffight86 drafnothom86 drafpolice86 drafupsfrd86 drafupspar86 drafupsprt86"
global alc_perceived_harm_HAD	"dkfight86 dkbdhlth86 dkntdang86 dkprghrm86"
	global alc_perceived_harm		"${alc_perceived_harm_FOW} ${alc_perceived_harm_HAD}"
global alc_whystop_FOW			"stpalsoc86 stpallik86 stpalsik86 stpalill86 stpalodl86"
	global alc_whystop				"${alc_whystop_FOW}"
global alc_attitudes_other_HAD	"dkntrlmn86 dkadenjy86 dknowrng86 dkstpnsh86 dklkself86 dkwrryad86"	
	global alc_attitudes_other		"${alc_attitudes_other_HAD}"

**GLOBALS: IVs - Attitudes based on the globals above**
global alcpolyfactors		"alcpolyfac1_86 alcpolyfac2_86 alcpolyfac3_86 alcpolyfac4_86"
global alcfullfactors			"alcfac1_86 alcfac2_86 alcfac3_86 alcfac4_86"
*global alc_factors_sq		"alcpolysq1 alcpolysq2 alcpolysq3 alcpolysq4"

** GLOBALS: IV - Attitude controls**
global teendrinking			"i.alcfreqG86"			// See also raredrink86 - but I've assumed it's fine without this
global smoking 				"i.smkgrp86 smokpolyfac1_86 smokpolyfac2_86"
global delinquency			"delinqscore86"			// Note that this is in a different section of the questionnaire so will reduce the n
global drug_use 			"i.druguse86 drugpolyfac86"






**************************************
** IVs 2: Parents ********************
**************************************

** GLOBALS: IV - Parental drinking**
global parents_drinkingS		"i.alcpar86"		// The max drinking level from i.dkalfa86 i.dkalmo86
global parents_alcattS			"i.dkview86"
global pregdrink				"i.pregdrink80"

** GLOBALS: Controls for Parental drinking**
global parents_smoking 			"i.smkpar86"
global parents_contact			"i.parcontact86 incare00"	
global parents_strictness		"parexpect86 ptstrctN86"			// One of these is the latent factor, the other is a single q
global parents_allcontrols		"${parents_smoking} ${parents_contact} ${parents_strictness}"

/* GLOBALS: IV - Peer drinking
global peer_drinking			"i.dkalbfrd86 i.dkalnext86"
	global peer_drinkingB		"  dkalbfrd86   dkalnext86"
	global peer_drinkingS		"i.alcfriend86"
*/




