///////////////////////////////
// Created by BB 26/7/2013

***************************************************************
***************************************************************
* The global
***************************************************************
***************************************************************

global fixedvars 	"bcsid male hinvq04 incare00 pregdrink80 *86"
global timevars		"lifesat alctotunNEW alctotunOLD alcgrpNEW alcgrpOLD drinks alcfreq nevdrk cagelife cageyr cage1 cage2 "
global timevars		"${timevars} cohab tchild0_5 tchild6_17 anykids0_5 anykids6_17 emp activ lsi poorhlth support housing "
global timevars		"${timevars} relweek netpcinc loginc wrktrav wrkhours wrkhoursG currsmk cigsday pregnant"
* Creating the text syntax to keep all versions of these variables
local timevars 	"$timevars"
global timevartext	""
foreach var in `timevars'	{
	global timevartext "${timevartext} `var'??"
	global `var'LAB: variable label `var'00
	/**/					}

	
	
***************************************************************
* The reshaping
***************************************************************

keep ${fixedvars} ${timevartext}
reshape long ${timevars}, i(bcsid) j(wave 00 04 12)
order *86, after(wave)
local timevars 	"$timevars"
foreach var in `timevars'	{
	dis "${`var'LAB}"
	label var `var' "${`var'LAB}"
	/**/					}




***************************************************************
* Misc leaning
***************************************************************

foreach version in OLD NEW	{
	capture gen alcsq`version' = alctotun`version'^2
	label var alcsq`version' "alctotun`version'^2"
/**/						}


***************************************************************
* Practical necessities
***************************************************************
bysort bcsid: gen one = (_n==1)
	gen bcsnumid = sum(one)
	label var bcsnumid "Person identifier, numeric"
	drop one
sort bcsid wave
	capture gen uniqueid = _n
	label var uniqueid "Person-wave identifier, numeric"
recode wave (0=1 "1_2000")(4=2 "2_2004")(12=3 "3_2012"), gen(wavenum)
drop wave
order _all, alphabetic
order bcsid bcsnumid uniqueid *80 *86, first
compress
tsset bcsnumid wavenum



save temp\reshaped.dta, replace


