* This was part of the main analysis in v4, but the reviewers suggested we remove the IV analyses completely - which is sad

	
***************************************************************************
***************************************************************************
***************************************************************************
** IV models
***************************************************************************
***************************************************************************
***************************************************************************
	
///////////////////////////////////////
// Main IV models
* Overall variables
local controls 	"${stablevars} ${varyvars} "	// for all models
local indvars1	"alctotunOLD"
local indvars2	"alctotunOLD alcsqOLD"
local indvars3	"cageyr"
* The list of instruments & related controls - set 1 (attitudes to alcohol)
	// Taken out - separate models for alcpolyfac1_86-alcpolyfac4_86, and also the non-polychoric factors $alcfullfactors
	local instruments40 "$alcpolyfactors"							
		local controls40 	""
	local instruments41	"$alcpolyfactors"
		local controls41 	" ${smoking}"		
	local instruments42	"$alcpolyfactors"
		local controls42	"${smoking} ${delinquency} ${drug_use}"			// With additional control that reduces sample size
* The list of instruments & related controls - set 2 (parental drinking- removing $peer_drinkingS as an instrument)
	// Taken out - separate models for $parents_drinkingS $parents_alcattS ${pregdrink}
	local instruments50 "$parents_drinkingS $parents_alcattS ${pregdrink}"	
		local controls50	""
	local instruments51	"$parents_drinkingS $parents_alcattS ${pregdrink}"
		local controls51	"${parents_allcontrols}"
	local instruments52	"$parents_drinkingS $parents_alcattS ${pregdrink}"
		local controls52	"${parents_allcontrols} ${delinquency} ${drug_use}"			// Seeing how important the delinquency score is
* The list of instruments & related controls - COMBINED
	local instruments60 "`instruments41' `instruments51'"	// With no controls at age 16	
	local instruments61 "`instruments41' `instruments51'" 	// With main controls (smoking, parental controls)
		local controls61	"`controls41' `controls51'"
	local instruments62 "`instruments42' `instruments51'"	// With additional controls	(delinquency, drug use) that reduce sample size
		local controls62	"`controls42' `controls51'"
* Specific instruments for each outcome var 
	* This includes models 65-67, mirroring 60-62 above
	local controls65	""
	local controls66	"`controls41' `controls51'"
	local controls67	"`controls42' `controls51'"
	reg alctotunOLD		 `instruments41' `instruments51' `controls' `controls41' `controls51' if alctotunNEW<${maxalc}, vce(cluster bcsnumid)
		local indvar_instr65_1 "alcpolyfac1_86 alcpolyfac2_86 i.alcpar86"								// alctotunNEW-Instruments that are sig in the first stage equation for linear
	reg alcsqOLD alctotunOLD `instruments41' `instruments51' `controls' `controls41' `controls51' if alctotunNEW<${maxalc}, vce(cluster bcsnumid) 	// Not sure this does what I think it does...
		local indvar_instr65_2 "alcpolyfac2_86 i.alcpar86"				// alcsqNEW-Instruments that are sig in the first stage equation for quadratic
	logit cageyr 			 `instruments41' `instruments51' `controls' `controls41' `controls51' if alctotunNEW<${maxalc}, vce(cluster bcsnumid)
		local indvar_instr65_3 "alcpolyfac1_86 alcpolyfac2_86 i.alcpar86"								// CAGE-Instruments that are sig in the first stage equation for CAGE

* The regresion model itself
forvalues j = 1/3	{
	forvalues i = 40/67	{
		* The indvar-specific varlists
			if (`i'>=65 & `i'<=67)		local instruments`i' = "`indvar_instr65_`j''"
		* Check that identified
			dis _newline(10) in red "Reg `i' has wordcount(endogenous)=" wordcount("`indvars`j''") _s(5) " with wordcount(instruments)=" wordcount(`"`instruments`i''"')
			scalar identified = (wordcount("`instruments`i''") - wordcount("`indvars`j''"))
		if "`instruments`i''"~="" & identified>=0	{
		* The command line
			eststo iv`j'_`i': ivregress gmm lifesat (`indvars`j''= `instruments`i'') `controls' `controls`i'' if alctotunNEW<${maxalc}, wmatrix(cluster bcsnumid)	
		* Postestimation commands - see Stata help file under ivregress postestimation for explanations
			dis _newline(2) in red "Joint test of independent variables"
				test `indvars`j''
				estadd scalar jointtest = r(p)
			matrix firstworking = e(b)'
				if `j'==2 * ((firstworking[1,1]>0 & firstworking[2,1]<0) | (firstworking[1,1]<0 & firstworking[2,1]>0))	{
				dis _newline(2) in red "Turning point"
					estadd scalar turningpoint = -firstworking[1,1]/(2*firstworking[2,1])
				dis _newline(2) in red "Consumption with happiness equal to abstaining"
					estadd scalar abstequiv = -firstworking[1,1]/(firstworking[2,1])
				/**/																									}
			dis _newline(2) in red "Durbin-Wu-Hausman test of regressor endogeneity" ///
					_newline(1) "ns means that indvars can be treated as exogenous & not needing an IV"
				estat endogenous
				estadd scalar durbinwh_p  = r(p_C)			
				estadd scalar durbinwh_C  = r(C)					// chi-squared statistic
				estadd scalar durbinwh_df = r(df)			
			dis _newline(2) in red "Weak instrument diagnostics - we want:" ///
					_newline(1) "(1) a. If 1 endogenous regressor: F>10 in first-stage summary stats, to show a strong enough predictor" ///
					_newline(1) "    b. If 2+ endog. regressors: decide on an acceptable adjusted partial R-squared"					 ///
					_newline(1) "(2) Eigenvalue > our chosen cut-off - go for: 2SLS size of nominally 5% Wald test"
				estat firststage, forcenonrobust
				if wordcount("`indvars`j''") == 1	{
					matrix Mfirststage = r(singleresults)
					estadd scalar weak_pr2 = Mfirststage[1,3]	
					estadd scalar weak_F = Mfirststage[1,4]		
					estadd scalar weak_p = Mfirststage[1,7]		
					estadd scalar weak_eig = r(mineig)			
					matrix eigworking = r(mineigcv)
					estadd matrix eigvals = eigworking				
					/**/						}
				else							{
					matrix Mfirststage = r(multiresults)
					estadd scalar weak_pr2 		= Mfirststage[1,1]	
					estadd scalar weak_pr2_v2 	= Mfirststage[2,1]	
					estadd scalar weak_eig = r(mineig)			
					matrix eigworking = r(mineigcv)
					estadd matrix eigvals = eigworking				
					/**/						}
			dis _newline(2) in red "Hansen-Sargan overidentification test"		///
				_newline(1) "Sig values indicate problems with some instruments or the model"
				capture estat overid
				if _rc==0 	{
					estat overid
					estadd scalar overid = r(p_HansenJ)		
					/**/	}
					
		* Closing loops
			/**/							}			// Loop to check that this regressor list isn't empty
		/**/			}								// Loop over regressors
	/**/			}									// Loop over outcome vars
// End main IV models

	
///////////////////////////////////////
// IV models for weak instruments 
	/* 	NOTE The only command that works is IVREG2, providing weak instrument-robust tests of joint significance of endogenous 
		regressors B1 in main equation - RIVTEST 2009 and CONDIVREG 2006 can only handle one endogenous regressor 
	END NOTE */
log using "${dodir}\ivweak.txt", text name(ivweak) replace		// ESTSTO doesn't capture the bit of this that I want to use
dis in red _newline(2) "The IVREG2 help explains the key figures as follows: The first-stage output also includes two statistics that provide weak-instrument robust inference for testing the significance of the endogenous regressors in the structural equation being estimated.  The first statistic is the Anderson-Rubin (1949) test (not to be confused with the Anderson-Rubin overidentification test for LIML estimation; see above).  The second is the closely related Stock-Wright (2000) S statistic.  The null hypothesis tested in both cases is that the coefficients of the endogenous regressors in the structural equation are jointly equal to zero, and, in addition, that the overidentifying restrictions are valid.  Both tests are robust to the presence of weak instruments.  The tests are equivalent to estimating the reduced form of the equation (with the full set of instruments as regressors) and testing that the coefficients of the excluded instruments are jointly equal to zero.  In the form reported by ivreg2,the Anderson-Rubin statistic is a Wald test and the Stock-Wright S statistic is a GMM-distance test.  Both statistics are distributed as chi-squared with L1 degrees of freedom, where L1=number of excluded instruments.  The traditional F-stat version of the Anderson-Rubin test is also reported.  See Stock and Watson (2000), Dufour (2003), Chernozhukov and Hansen (2005) and Kleibergen (2007) for further discussion.  For related alternative test statistics that are also robust to weak instruments, see condivreg and rivtest, and the corresponding discussions in Moreira and Poi (2003) and Mikusheva and Poi (2006), and in Finlay and Magnusson (2009), respectively." 
dis "${stablevars} ${varyvars} ${smoking} ${parents_allcontrols}"
local ivcontrols "male i.hinvq04 i.wave i.cohab anykids0_5 anykids6_17 i.activ i.wrktrav i.wrkhoursG lsi i.housing relweek loginc  i.currsmk cigsday pregnant i.smkgrp86 smokpolyfac1_86 smokpolyfac2_86  i.smkpar86 i.parcontact86 incare00 parexpect86 ptstrctN86"
local indvars1	"alctotunOLD"
local indvars2	"alctotunOLD alcsqOLD"
local indvars3	"cageyr"
*Taken from above
	local indvar_instr65_1 "alcpolyfac1_86 alcpolyfac2_86 i.alcpar86"								// CAGE-Instruments that are sig in the first stage equation for CAGE
	local indvar_instr65_2 "alcpolyfac1_86 alcpolyfac2_86 alcpolyfac3_86 i.alcpar86"				// alcsqNEW-Instruments that are sig in the first stage equation for quadratic
	local indvar_instr65_3 "alcpolyfac1_86 alcpolyfac2_86 i.alcpar86"								// alctotunNEW-Instruments that are sig in the first stage equation for linear
forvalues j = 1/3	{
	dis in red _newline(20) "Weak instrument tests for `indvar_instr65_`j''" _newline(1) "See 'Weak instrument-robust inference', look at Cameron-Trivedi & .do file for explanation"
	xi: ivreg2 lifesat ((`indvars`j'')=`indvar_instr65_`j'') `ivcontrols'  if alctotunNEW<${maxalc}, first robust cluster(uniqueid)
	/**/			}
capture log close ivweak
	


***************************************************
***************************************************
** Results for IV models, plus comparisons
***************************************************
***************************************************

estwrite * using "${dir}\estimates_IV_${filename}", id(uniqueid) replace
/*
estimates drop _all
estread using "${dir}\estimates_OLSandFE_${filename}", id(uniqueid)
estread using "${dir}\estimates_IV_${filename}", id(uniqueid)
*/

global ivmodels "40 all factors, no controls || 41 + controls || 42 + controls that reduce n "
global ivmodels	"${ivmodels} 50 parental IVs || 51 + controls || 52 + delinquency/drugs "
global ivmodels	"${ivmodels} 60 all instruments || 61 +controls || 62 +delinquency/drug use controls"
global ivmodels	"${ivmodels} 65 only sig instruments || 66 +control || 67 +delinquency/drug use controls (should be 66)"

/* Linear IVs don't really work to be honest - we know this isn't linear
* Quadratic IVs
esttab iv2_4* iv2_5*, star(+ 0.10 * 0.05 ** 0.01 *** 0.001) not scalars(jointtest durbinwh_p weak_pr2 weak_F weak_p weak_pr2_v2 weak_eig overid turningpoint abstequiv) ///
	sfmt(%4.3f %4.3f %4.3f %3.2f %4.3f %4.3f %3.2f) nodepvars compress order(*alc*) drop(*b.*) varwidth(25) nodepvars nonumbers note(${ivmodels})
esttab iv2_6*, star(+ 0.10 * 0.05 ** 0.01 *** 0.001) not scalars(jointtest durbinwh_p weak_pr2 weak_F weak_p weak_pr2_v2 weak_eig overid turningpoint abstequiv) ///
	sfmt(%4.3f %4.3f %4.3f %3.2f %4.3f %4.3f %3.2f) nodepvars compress order(*alc*) drop(*b.*) varwidth(25) nodepvars nonumbers note(${ivmodels})

* CAGE IVs
esttab iv3_4* iv2_5*, star(+ 0.10 * 0.05 ** 0.01 *** 0.001) not scalars(jointtest durbinwh_p weak_pr2 weak_F weak_p weak_pr2_v2 weak_eig overid turningpoint abstequiv) ///
	sfmt(%4.3f %4.3f %4.3f %3.2f %4.3f %4.3f %3.2f) nodepvars compress order(*cage*) drop(*b.*) varwidth(25) nodepvars nonumbers note(${ivmodels})
esttab iv3_6*, star(+ 0.10 * 0.05 ** 0.01 *** 0.001) not scalars(jointtest durbinwh_p weak_pr2 weak_F weak_p weak_pr2_v2 weak_eig overid turningpoint abstequiv) ///
	sfmt(%4.3f %4.3f %4.3f %3.2f %4.3f %4.3f %3.2f) nodepvars compress order(*cage*) drop(*b.*) varwidth(25) nodepvars nonumbers note(${ivmodels})
*/
// OUTPUT TO EXCEL
esttab iv* using `"${dodir}\0.output_IV.csv"', csv replace not r2 scalars("df_b control df" _ jointtest durbinwh_p weak_pr2 weak_F weak_p weak_pr2_v2 weak_eig overid __ turningpoint abstequiv) ///
	sfmt(%2.0f %3.2f %3.2f %3.2f %3.2f %3.2f %3.2f %3.2f %2.1f) order(*inc *alc* *cage*) star(+ 0.10 * 0.05 ** 0.01) varwidth(25) nodepvars nonumbers
	
